base-install-scripts/pacstrap.in
Dave Reisner 542e888b48 pacstrap/arch-chroot: require root privileges to run
Suggested by Pierre. This makes sense since somewhere along the line,
pacman or mount are going to complain.
2012-06-19 08:13:52 -04:00

83 lines
1.9 KiB
Bash

#!/bin/bash
#
# Assumptions:
# 1) User has partitioned, formatted, and mounted partitions on /mnt
# 2) Network is functional
# 3) Arguments passed to the script are valid pacman targets
# 4) A valid mirror appears in /etc/pacman.d/mirrorlist
#
shopt -s extglob
m4_include(common)
declare newroot=/mnt
usage() {
cat <<EOF
usage: ${0##*/} [options]
Options:
-r root Install to 'root' (default: /mnt)
-d Allow installation to a non-mountpoint directory
EOF
}
if [[ -z $1 || $1 = @(-h|--help) ]]; then
usage
exit $(( $# ? 0 : 1 ))
fi
(( EUID == 0 )) || die 'This script must be run with root privileges'
while getopts ':dr:' flag; do
case $flag in
d)
directory=1
;;
r)
newroot=$OPTARG
;;
:)
die '%s: option requires an argument -- '\''%s'\' "${0##*/}" "$OPTARG"
;;
?)
die '%s: invalid option -- '\''%s'\' "${0##*/}" "$OPTARG"
;;
esac
done
shift $(( OPTIND - 1 ))
if (( $# )); then
packages=("$@")
else
packages=('base' 'base-devel')
fi
[[ -d $newroot ]] || die "%s is not a directory" "$newroot"
if ! mountpoint -q "$newroot" && (( ! directory )); then
die '%s is not a mountpoint!' "$newroot"
fi
# create obligatory directories
msg 'Creating install root at %s' "$newroot"
mkdir -p "$newroot/var/lib/pacman" "/$newroot"/{dev,proc,sys,run,tmp,etc}
# always call umount on quit after this point
trap 'api_fs_umount "$newroot" 2>/dev/null' EXIT
# mount API filesystems
api_fs_mount "$newroot" || die "failed to setup API filesystems in new root"
msg 'Installing packages to %s' "$newroot"
if ! pacman -r "$newroot" -Sy --noconfirm "${packages[@]}"; then
die 'Failed to install packages to new root'
fi
# if there's a keyring on the host, copy it into the new root
[[ -d /etc/pacman.d/gnupg ]] && cp -a /etc/pacman.d/gnupg "$newroot/etc/pacman.d/"
# vim: et ts=2 sw=2 ft=sh: